# coding: utf-8

"""
    EPIC API

    REST API for interacting with EPIC (https://epic.zenotech.com) services. <br />                             Please note this API is in BETA and does not yet contain                             all EPIC functionality.  # noqa: E501

    The version of the OpenAPI document: v2
    Contact: support@zenotech.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from epiccore.configuration import Configuration


class EnvVarTemplate(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'variable_name': 'str',
        'help_text': 'str',
        'var_type': 'str',
        'default': 'str'
    }

    attribute_map = {
        'variable_name': 'variable_name',
        'help_text': 'help_text',
        'var_type': 'var_type',
        'default': 'default'
    }

    def __init__(self, variable_name=None, help_text=None, var_type=None, default=None, local_vars_configuration=None):  # noqa: E501
        """EnvVarTemplate - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._variable_name = None
        self._help_text = None
        self._var_type = None
        self._default = None
        self.discriminator = None

        self.variable_name = variable_name
        self.help_text = help_text
        self.var_type = var_type
        if default is not None:
            self.default = default

    @property
    def variable_name(self):
        """Gets the variable_name of this EnvVarTemplate.  # noqa: E501


        :return: The variable_name of this EnvVarTemplate.  # noqa: E501
        :rtype: str
        """
        return self._variable_name

    @variable_name.setter
    def variable_name(self, variable_name):
        """Sets the variable_name of this EnvVarTemplate.


        :param variable_name: The variable_name of this EnvVarTemplate.  # noqa: E501
        :type variable_name: str
        """
        if self.local_vars_configuration.client_side_validation and variable_name is None:  # noqa: E501
            raise ValueError("Invalid value for `variable_name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                variable_name is not None and len(variable_name) > 100):
            raise ValueError("Invalid value for `variable_name`, length must be less than or equal to `100`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                variable_name is not None and len(variable_name) < 1):
            raise ValueError("Invalid value for `variable_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._variable_name = variable_name

    @property
    def help_text(self):
        """Gets the help_text of this EnvVarTemplate.  # noqa: E501


        :return: The help_text of this EnvVarTemplate.  # noqa: E501
        :rtype: str
        """
        return self._help_text

    @help_text.setter
    def help_text(self, help_text):
        """Sets the help_text of this EnvVarTemplate.


        :param help_text: The help_text of this EnvVarTemplate.  # noqa: E501
        :type help_text: str
        """
        if self.local_vars_configuration.client_side_validation and help_text is None:  # noqa: E501
            raise ValueError("Invalid value for `help_text`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                help_text is not None and len(help_text) > 300):
            raise ValueError("Invalid value for `help_text`, length must be less than or equal to `300`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                help_text is not None and len(help_text) < 1):
            raise ValueError("Invalid value for `help_text`, length must be greater than or equal to `1`")  # noqa: E501

        self._help_text = help_text

    @property
    def var_type(self):
        """Gets the var_type of this EnvVarTemplate.  # noqa: E501


        :return: The var_type of this EnvVarTemplate.  # noqa: E501
        :rtype: str
        """
        return self._var_type

    @var_type.setter
    def var_type(self, var_type):
        """Sets the var_type of this EnvVarTemplate.


        :param var_type: The var_type of this EnvVarTemplate.  # noqa: E501
        :type var_type: str
        """
        if self.local_vars_configuration.client_side_validation and var_type is None:  # noqa: E501
            raise ValueError("Invalid value for `var_type`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                var_type is not None and len(var_type) > 300):
            raise ValueError("Invalid value for `var_type`, length must be less than or equal to `300`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                var_type is not None and len(var_type) < 1):
            raise ValueError("Invalid value for `var_type`, length must be greater than or equal to `1`")  # noqa: E501

        self._var_type = var_type

    @property
    def default(self):
        """Gets the default of this EnvVarTemplate.  # noqa: E501


        :return: The default of this EnvVarTemplate.  # noqa: E501
        :rtype: str
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this EnvVarTemplate.


        :param default: The default of this EnvVarTemplate.  # noqa: E501
        :type default: str
        """
        if (self.local_vars_configuration.client_side_validation and
                default is not None and len(default) > 300):
            raise ValueError("Invalid value for `default`, length must be less than or equal to `300`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                default is not None and len(default) < 1):
            raise ValueError("Invalid value for `default`, length must be greater than or equal to `1`")  # noqa: E501

        self._default = default

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EnvVarTemplate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EnvVarTemplate):
            return True

        return self.to_dict() != other.to_dict()
